Attribute VB_Name = "CurveFunctions"
Option Explicit

' Find the least squares linear fit.
' Return the total error.
Public Function FindLinearLeastSquaresFit(ByVal PtX As Collection, ByVal PtY As Collection, ByRef m As Double, ByRef b As Double) As Double
Dim S1 As Double
Dim Sx As Double
Dim Sy As Double
Dim Sxx As Double
Dim Sxy As Double
Dim i As Integer

    ' Perform the calculation.
    ' Find the values S1, Sx, Sy, Sxx, and Sxy.
    S1 = PtX.Count
    Sx = 0
    Sy = 0
    Sxx = 0
    Sxy = 0
    For i = 1 To PtX.Count
        Sx = Sx + PtX.Item(i)
        Sy = Sy + PtY.Item(i)
        Sxx = Sxx + PtX.Item(i) * PtX.Item(i)
        Sxy = Sxy + PtX.Item(i) * PtY.Item(i)
    Next i

    ' Solve for m and b.
    m = (Sxy * S1 - Sx * Sy) / (Sxx * S1 - Sx * Sx)
    b = (Sxy * Sx - Sy * Sxx) / (Sx * Sx - S1 * Sxx)

    FindLinearLeastSquaresFit = Sqr(ErrorSquared(PtX, PtY, m, b))
End Function

' Return the error squared.
Public Function ErrorSquared(ByVal PtX As Collection, ByVal PtY As Collection, ByVal m As Double, ByVal b As Double) As Double
Dim i As Integer
Dim total As Double
Dim dy As Double

    total = 0
    For i = 1 To PtX.Count
        dy = PtY.Item(i) - (m * PtX.Item(i) + b)
        total = total + dy * dy
    Next i
    ErrorSquared = total
End Function

