VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_linear_least_squares"
   ClientHeight    =   3165
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6030
   LinkTopic       =   "Form1"
   ScaleHeight     =   3165
   ScaleWidth      =   6030
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdGraph 
      Caption         =   "Graph"
      Height          =   375
      Left            =   4200
      TabIndex        =   10
      Top             =   2640
      Width           =   1215
   End
   Begin VB.TextBox txtError 
      Height          =   285
      Left            =   3720
      TabIndex        =   9
      Top             =   2160
      Width           =   2175
   End
   Begin VB.TextBox txtB 
      Height          =   285
      Left            =   3720
      TabIndex        =   7
      Top             =   1800
      Width           =   2175
   End
   Begin VB.TextBox txtM 
      Height          =   285
      Left            =   3720
      TabIndex        =   5
      Top             =   1440
      Width           =   2175
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear"
      Height          =   375
      Left            =   4680
      TabIndex        =   3
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton cmdFit 
      Caption         =   "Fit"
      Height          =   375
      Left            =   3240
      TabIndex        =   2
      Top             =   720
      Width           =   1215
   End
   Begin VB.PictureBox picGraph 
      Height          =   2895
      Left            =   120
      ScaleHeight     =   189
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   189
      TabIndex        =   0
      Top             =   120
      Width           =   2895
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Error:"
      Height          =   195
      Index           =   2
      Left            =   3240
      TabIndex        =   8
      Top             =   2160
      Width           =   375
   End
   Begin VB.Label Label2 
      Caption         =   "b:"
      Height          =   255
      Index           =   1
      Left            =   3240
      TabIndex        =   6
      Top             =   1800
      Width           =   255
   End
   Begin VB.Label Label2 
      Caption         =   "m:"
      Height          =   255
      Index           =   0
      Left            =   3240
      TabIndex        =   4
      Top             =   1440
      Width           =   255
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "y = m * x + b"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   435
      Left            =   3600
      TabIndex        =   1
      Top             =   120
      Width           =   1950
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private HasSolution As Boolean
Private BestM As Double
Private BestB As Double
Private PtX As Collection
Private PtY As Collection

' Set up.
Private Sub Form_Load()
    HasSolution = False
    Set PtX = New Collection
    Set PtY = New Collection
End Sub

' Save a new point.
Private Sub picGraph_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Save the point.
    PtX.Add X
    PtY.Add Y
    picGraph.Refresh
End Sub

' Draw the points and best fit curve.
Private Sub picGraph_Paint()
Dim y0 As Double
Dim y1 As Double
Dim dx As Single
Dim dy As Single
Dim i As Integer

    ' Draw the curve.
    If (HasSolution) Then
        y0 = BestM * 0 + BestB
        y1 = BestM * ScaleWidth + BestB
        picGraph.Line (0, y0)-(ScaleWidth, y1), vbBlue
    End If

    ' Draw the points.
    dx = picGraph.ScaleWidth / 100
    dy = picGraph.ScaleHeight / 100
    picGraph.FillColor = vbWhite
    picGraph.FillStyle = vbFSSolid
    For i = 1 To PtX.Count
        picGraph.Line (PtX.Item(i) - dx, PtY.Item(i) - dy)-Step(2 * dx, 2 * dy), vbBlack, B
    Next i
End Sub

' Clear the points.
Private Sub cmdClear_Click()
    HasSolution = False
    Set PtX = New Collection
    Set PtY = New Collection
    picGraph.Refresh

    txtM.Text = ""
    txtB.Text = ""
    txtError.Text = ""
End Sub

' Find parameters for a curve fit.
Private Sub cmdFit_Click()
Dim start_time As Single
Dim stop_time As Single

    Me.MousePointer = vbHourglass
    txtM.Text = ""
    txtB.Text = ""
    txtError.Text = ""
    DoEvents
    start_time = Timer

    ' Find a good fit.
    FindLinearLeastSquaresFit PtX, PtY, BestM, BestB

    stop_time = Timer
    Debug.Print Format$(stop_time - start_time, "0.0000")

    txtM.Text = Format$(BestM)
    txtB.Text = Format$(BestB)

    ' Display the error.
    ShowError

    ' We have a solution.
    HasSolution = True
    picGraph.Refresh

    Me.MousePointer = vbDefault
End Sub

' Display the error.
Private Sub ShowError()
Dim err As Double

    ' Get the error.
    err = Sqr(ErrorSquared( _
        PtX, PtY, BestM, BestB))
    txtError.Text = Format$(err)
End Sub

' Regraph with the given parameters.
Private Sub cmdGraph_Click()
    BestM = CDbl(txtM.Text)
    BestB = CDbl(txtB.Text)
    ShowError
    picGraph.Refresh
End Sub

